#include "triangulo.h"
#include "pascal.h"

//ésta función InsertarFila es privada, sólo accesible desde las funciones de pascal.cpp

void InsertarFila(Pascal &p){	
	NuevaFila(p.tri); 	//crea una nueva fila vacia, la que corresponda
	int filas=NumeroFilas(p.tri);
	int val;
	for(int i=filas-1;i<filas;i++){ //le da los valores correspondientes a las componentes de la fila recién creada
		for(int j=0;j<=i;j++){
			if(j==0||j==i){
				val=1;
			}
			else{
				val=Obtener(p.tri,i-1,j-1)+Obtener(p.tri,i-1,j);
			}
			Asignar(p.tri, i, j,val);
		}
	}	
}

void Inicializar(Pascal &p){ //Inicializa el triángulo a “Triángulo vacío”.
	Inicializar(p.tri);
}
  
void Liberar(Pascal &p){ //Libera la memoria ocupada por el triángulo.
	Liberar(p.tri);
}
  
int Obtener(Pascal &p, int f, int c){ //Devuelve el coeficiente de la fila f y la columna c.
	int nf=NumeroFilas(p.tri);
	if(f>nf-1){		//Para crear sólo las filas que sean necesarias
		for(int i=nf-1;i<f;i++){
			InsertarFila(p);
		}
	}
	return Obtener(p.tri,f,c);
}
  
void Mostrar(Pascal &p, int n){ //Muestra en consola el triángulo de Pascal de n filas.
	int nf=NumeroFilas(p.tri);
	if(n>nf){			//Para que inserte solo las filas necesarias
		for(int i=nf;i<n;i++){
			InsertarFila(p);
		}
	}
	Mostrar(p.tri,n);
}
  
int Fibonacci(Pascal &p, int n){ //Devuelve el valor del término n-ésimo de la serie de Fibonacci haciendo uso del triángulo
  				//de Pascal p.
	int nf=NumeroFilas(p.tri);
	if(n>nf){			//Para que inserte solo las filas necesarias
		for(int i=nf;i<n;i++){
			InsertarFila(p);
		}
	}

	int resultado=0;
	
	for(int i=n,j=0; i>=0; i--,j++){
		if(i>=j){					
			resultado=resultado+Obtener(p,i,j);
		}
	}
	
	return resultado;
}


