#include "triangulo.h"

void Inicializar(Triangulo &t){ // Inicializa t a “Triángulo vacío”.
	t.filas=0;
	t.ptr=0;
}

void Liberar(Triangulo &t){ // Libera la memoria dinámica ocupada por el triángulo.
	if(t.filas>0){
		delete[]t.ptr[0];
		delete[]t.ptr;
	}
}

void NuevaFila(Triangulo &t){ // Añade una nueva fila en la base del triángulo. No es necesario inicializar los elementos 
					//de la nueva fila a ningún valor concreto.
	t.filas=t.filas+1;
	int **aux=new int* [t.filas];
	
	//calcular el numero de componentes que va a tener el vector que contiene al triangulo en si
	int suma=0;

	for(int j=0;j<=t.filas;j++){
		suma=suma+j;
	}

	aux[0]=new int[suma];

	for(int k=1;k<t.filas;k++){ //este bucle para organizar los punteros
		aux[k]=aux[k-1]+k;
	}
	
	

	if(t.filas-1>0){ // copiar punteros del que estaba creado al nuevo
		for(int i=0;i<t.filas-1;i++){
			for(int j=0;j<=i;j++){
				aux[i][j]=t.ptr[i][j];
			}
		}
		delete[]t.ptr[0];
		delete[]t.ptr;
	}

	t.ptr=aux; //aquí se modifica la dirección del puntero 	
}	

void BorraFila(Triangulo &t){ // Borra la última fila del triángulo (la de la base).
	t.filas=t.filas-1;
	int **aux=new int* [t.filas];
	
	//calcular el numero de componentes que va a tener el vector que contiene al triangulo en si
	int suma=0;

	for(int j=0;j<=t.filas;j++){
		suma=suma+j;
	}

	aux[0]=new int[suma];

	for(int k=1;k<t.filas;k++){
		aux[k]=aux[k-1]+k;
	}
	
	if(t.filas>0){
		for(int i=0;i<t.filas-1;i++){
			for(int j=0;j<=i;j++){
				aux[i][j]=t.ptr[i][j];
			}
		}
		delete[]t.ptr[0];
		delete[]t.ptr;
	}
	
	t.ptr=aux; //aquí se modifica la dirección del puntero 	
}

void Asignar(Triangulo &t, int fil, int col, int val){ // Asigna el valor val al elemento que está en la fila fil y en la columna col del triángulo.
	(t.ptr[fil][col])=val;
}
  
int Obtener(const Triangulo &t, int fil, int col){ // Devuelve el valor del elemento situado en la fila fil y la columna col.
	return (t.ptr[fil][col]);
}
  
int NumeroFilas(const Triangulo &t){ // Devuelve el número de filas que tiene el triángulo.
	return t.filas;
}

void Mostrar(const Triangulo &t, int n){ // Muestra las n primeras filas del triángulo en consola (la cúspide del triángulo). Si n
  						//vale cero (valor por defecto) mostrará el triángulo completo.
	
	int tope=n;					
	if(n==0){
		tope=t.filas;
	}
	
	for(int i=0;i<tope;i++){
		
		for(int k=(t.filas-(i+1))*3;k>0;k--){ //para los espacios antes de imprimir cada linea del triángulo
			cout<<" ";
		}
		
		for(int j=0;j<=i;j++){
			if(t.ptr[i][j]<10){
				cout<<"  ";
			}
			else{
				if(t.ptr[i][j]<100){
					cout<<" ";
				}
			}
			
			cout<< t.ptr[i][j]<<"   ";
			
		}
		
		cout<<endl;
	}
}




